; GUI #
include win64a.inc
; --------------- 
WINDOWWIDTH  = 400
WINDOWHEIGHT = 440
.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC) shl 32 or \
	(sizeof WNDCLASSEX)       ;cbSize & style
	push	rax
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0
	cmp	msg.wParam,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT
local	i:DWORD
local	resulta:DWORD
local	resultb:DWORD

        xor	ebx,ebx
        mov	hWin,rcx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
        cmp	edx,WM_DESTROY
	je      wmDESTROY     
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY::invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hrc
	invoke	ReleaseDC,hWin,hDC
	invoke	RtlExitUserProcess,NULL
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hrc,rax
;   
	invoke	wglMakeCurrent,hDC,eax

	movd	xmm3,ebx
	movd	xmm2,ebx
	movd	xmm1,ebx
	movd	xmm0,ebx
	invoke  glClearColor;, 0.0, 0.0, 0.0, 0.0
	invoke  glShadeModel,GL_FLAT

	invoke	GLReshape, WINDOWWIDTH, WINDOWHEIGHT
        jmp	wmBYE
wmSIZE:; --------------- Resize the scene
	movzx	ecx,r9w
	mov	edx,r9d
	shr	edx,16
	invoke	GLReshape
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke	BeginPaint
; --------------- Display the scene
;  
	invoke	glClear,GL_COLOR_BUFFER_BIT
;select white for all lines
	mov	eax,const1 
	movd	xmm2,eax 
	movd	xmm1,eax 
	movd	xmm0,eax 
        invoke  glColor3f
;in 1st row, 3 lines, each with a different stipple
	invoke  glEnable, GL_LINE_STIPPLE
	invoke  glLineStipple, 1, 101h ;dotted

;     drawOneLine  50.0, 125.0, 150.0, 125.0
      invoke  glBegin, GL_LINES
	movd	xmm0,const50
	movd	xmm1,const125
      invoke  glVertex2f
	movd	xmm0,const150
	movd	xmm1,const125
      invoke  glVertex2f
      invoke  glEnd
     invoke  glLineStipple,1,0FFh ;dashed
;     drawOneLine  150.0, 125.0, 250.0, 125.0
	      invoke  glBegin, GL_LINES
	movd	xmm0,const150
	movd	xmm1,const125
      invoke  glVertex2f
	movd	xmm0,const250
	movd	xmm1,const125
      invoke  glVertex2f
      invoke  glEnd
     invoke  glLineStipple,1,1C47h ;dash/dot/dash
;     drawOneLine  250.0, 125.0, 350.0, 125.0
	      invoke  glBegin, GL_LINES
	movd	xmm0,const250
	movd	xmm1,const125
      invoke  glVertex2f
	movd	xmm0,const350
	movd	xmm1,const125
      invoke  glVertex2f
      invoke  glEnd
     ;in 2nd row, 3 wide lines, each with different stipple
	movd	xmm0,const5
	invoke  glLineWidth
	invoke  glLineStipple,1,101h ;dotted
;     drawOneLine  50.0, 100.0, 150.0, 100.0
	      invoke  glBegin, GL_LINES
	movd	xmm0,const50
	movd	xmm1,const100
	invoke  glVertex2f
	movd	xmm0,const150
	movd	xmm1,const100
	invoke  glVertex2f
	invoke  glEnd
	invoke  glLineStipple,1,0FFh ;dashed
;     drawOneLine  150.0, 100.0, 250.0, 100.0
	invoke  glBegin, GL_LINES
	movd	xmm0,const150
	movd	xmm1,const100
	invoke  glVertex2f
	movd	xmm0,const250
	movd	xmm1,const100
	invoke  glVertex2f
	invoke  glEnd	
	invoke  glLineStipple,1,1C47h ;dash/dot/dash
;     drawOneLine  250.0, 100.0, 350.0, 100.0
	invoke  glBegin, GL_LINES
	movd	xmm0,const250
	movd	xmm1,const100
	invoke  glVertex2f
	movd	xmm0,const350
	movd	xmm1,const100
	invoke  glVertex2f
	invoke  glEnd
	movd	xmm0,const1
	invoke  glLineWidth

;in 3rd row, 6 lines, with dash/dot/dash stipple as part of a single connected line strip
	invoke  glLineStipple,1,1C47h ;dash/dot/dash
	invoke  glBegin, GL_LINE_STRIP
	and	i,0
@@:	fld	const50
	fld     st
	fimul	i
	faddp
	fstp	resulta
	movd	xmm1,const75
	movd	xmm0,resulta
	invoke  glVertex2f
	inc	i
	cmp	i,7
	jc	@b
;in 4th row, 6 independent lines with same stipple
	and	i,0
@@:	fld	const50
	fld     st
	fimul	i
	faddp
	fstp	resulta

	fld	const50
	fld     st
	fild	i
	fld1
	faddp
	fmulp
	faddp
	fstp	resultb

;	     drawOneLine  [resulta], 50.0, [resultb], 50.0
	invoke  glBegin, GL_LINES
	movd	xmm0,resulta
	movd	xmm1,const50
	invoke  glVertex2f
	movd	xmm0,resultb
	movd	xmm1,const50
	invoke  glVertex2f
	invoke  glEnd
	inc	i
	cmp	i,6
	jc	@b
;in 5th row, 1 line, with dash/dot/dash stipple and a stipple repeat factor of 5
	invoke  glLineStipple, 5,1C47h ;dash/dot/dash  */
;     drawOneLine  50.0, 25.0, 350.0, 25.0
      invoke  glBegin, GL_LINES
	movd	xmm1,const25
	movd	xmm0,const50
      invoke  glVertex2f
	movd	xmm1,const25
	movd	xmm0,const350
      invoke  glVertex2f
      invoke  glEnd
     invoke  glDisable, GL_LINE_STIPPLE
        invoke  glFlush
;   
        invoke	SwapBuffers,hDC
	lea	edx,ps
	invoke	EndPaint,hWin
;--------------------------------------------------------------
wmBYE:	leave
	retn	
WndProc	endp
GLReshape proc w:dword, h:dword
local	resultqa:QWORD
local	resultqb:QWORD

	mov	w,ecx
	mov	h,edx

	mov	r8d,ecx
	mov	r9d,edx
	invoke  glViewport,0,0
	invoke  glMatrixMode,GL_PROJECTION
	invoke  glLoadIdentity

	fild	w
	fstp    resultqa
	fild	h
	fstp    resultqb
	movq	xmm3,resultqb
	movq	xmm2,rbx
	movq	xmm1,resultqa
	movq	xmm0,rbx
	invoke  gluOrtho2D
	leave
	retn
GLReshape endp
;----------------------------------------------------------------
hDC	dq	?
hrc	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR
;   
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1;  
;  ,     
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or \
	PFD_DRAW_TO_WINDOW 
  	iPixelType        db	PFD_TYPE_RGBA; RGBA 
  	cColorBits        db	16;   
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;  
  	cAlphaBits        db	0;  
  	cAlphaShift       db	0;  
  	cAccumBits        db	0;  
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;  
  	cDepthBits        db	0;32  Z- ( )
  	cStencilBits      db	0;  
  	cAuxBuffers       db	0;  
  	iLayerType        db	PFD_MAIN_PLANE;  
  	bReserved         db	0;
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;  

szClassName	db "Uncle Remus tales: Geometric Primitives",0
FileName	db "br_Rabbit3.cur",0
listName	dq 0
;float-----------------------------
const1		dd 1.0
const5		dd 5.0
const25		dd 25.0
const50		dd 50.0
const75		dd 75.0
const100	dd 100.0
const125	dd 125.0
const150	dd 150.0
const250	dd 250.0
const350	dd 350.0
end